#!/usr/bin/python

import  re, os
from string import strip

class vibrio_parser: 

	def __init__(self, filename): 
		self.mega_hash = {}
		self.parse_vibrio(filename)

	def parse_vibrio(self, filename): 
		input     = open(filename, 'r')
		for line in input.readlines(): 
			if line[0] == '>':
				curr  = line[0:14] 
				if curr == '>Q6L': raise 'asdasd'
				self.mega_hash[curr] = []
			else  :
				self.mega_hash[curr].append(line)
		input.close()

	def get_entry(self, key): 
		seq = self.mega_hash[key]
		seq = "".join(seq)
		seq = re.sub("\n|\r|\t", "", seq)
		return seq 
			
class alignment_record: 

	def __init__(self):
		self.org = None
		self.seq = None
		self.loc = None

	def __str__(self): 	return ">%s\n %s\n" %(self.org, self.seq)	


class alignment_result: 

	def __init__(self):  	self.records = {}

	def add_record(self, record): 	self.records[record.org] = record

	def get_record(self, org): return self.records[org]

	def get_seqs(self): 
		result = {}
		for org, record in self.records.items(): result[org] = re.sub('-','', record.seq)
		return result
		


def parse_alignment(filename, outfile): 
	
	cmd = "/usr/bin/clustalw ./%s" %filename
	os.system(cmd)
	input   = open(outfile, 'r')
	header  = input.readline()
	records = {}
	for line in input.readlines(): 
		label, seq  = strip(line[0 :30]), strip(line[30:  ])
		if not label: continue
		if records.has_key(label): records[label].append(seq)
		else                     : records[label] = [seq]
	input.close()
	total   = alignment_result()
	for i in records.keys():
		record     = alignment_record()
		record.org = i
		record.seq = "".join(records[i])
		total.add_record(record)
	return total

if __name__ == '__main__': parse_alignment2('test.msf', 'test.aln')		
	
