from string import lower, join, strip

code = {     'ttt': 'F', 'tct': 'S', 'tat': 'Y', 'tgt': 'C',
             'ttc': 'F', 'tcc': 'S', 'tac': 'Y', 'tgc': 'C',
             'tta': 'L', 'tca': 'S', 'taa': '*', 'tga': '*',
             'ttg': 'L', 'tcg': 'S', 'tag': '*', 'tgg': 'W',
             'ctt': 'L', 'cct': 'P', 'cat': 'H', 'cgt': 'R',
             'ctc': 'L', 'ccc': 'P', 'cac': 'H', 'cgc': 'R',
             'cta': 'L', 'cca': 'P', 'caa': 'Q', 'cga': 'R',
             'ctg': 'L', 'ccg': 'P', 'cag': 'Q', 'cgg': 'R',
             'att': 'I', 'act': 'T', 'aat': 'N', 'agt': 'S',
             'atc': 'I', 'acc': 'T', 'aac': 'N', 'agc': 'S',
             'ata': 'I', 'aca': 'T', 'aaa': 'K', 'aga': 'R',
             'atg': 'M', 'acg': 'T', 'aag': 'K', 'agg': 'R',
             'gtt': 'V', 'gct': 'A', 'gat': 'D', 'ggt': 'G',
             'gtc': 'V', 'gcc': 'A', 'gac': 'D', 'ggc': 'G',
             'gta': 'V', 'gca': 'A', 'gaa': 'E', 'gga': 'G',
             'gtg': 'V', 'gcg': 'A', 'gag': 'E', 'ggg': 'G'
         }

comp = {'a':'t', 'c':'g', 'g':'c', 't':'a'} 	 

def reverse_complement(seq): 
	seq = lower(seq)
	result = []
	for i in range(len(seq)-1,-1,-1): result.append( comp.get(seq[i]) or seq[i])
	return "".join(result)

def translate(seq): 
	seq = lower(seq)
	result = []
	for i in range(0, len(seq), 3): result.append(code.get(seq[i:i+3]) or '*')
	return "".join(result)		

def  clustalw_parser(filename): 
	input   = open(filename, 'r')
	header  = input.readline()
	records = {}
	for line in input.readlines(): 
		label = strip(line[0 :30])
		seq   = strip(line[31:  ])
		if not label: continue
		if records.has_key(label): records[label].append(seq)
		else                     : records[label] = [seq]
	input.close()
	return records

if __name__ == '__main__': 
	for label, seq in clustalw_parser('C1004.4.msf.aln').items(): print ">%s\n%s\n" %(label, seq)
