
import re, os

query    = re.compile("Query\:\s(.*)")
struct   = re.compile("SECTION_SS$")
surf     = re.compile("SECTION_SA$")
start    = re.compile("\>.*\d+\s+\d+$")
stop     = re.compile("END_SECTION")

def parseSable(filename):

	file    = open(filename, 'r')
	hash    = {}
	protein = None
	field   = None
	line    = 1
	while line:
		line = file.readline() 

		if query.match(line):
			result       = query.match(line)
			protein      = result.group(1)
			hash[protein]= {}
			
		elif struct.match(line): 
			field = 'struct'
			hash[protein][field] = {'Seq':'','SS':'','Conf':''}
			
		elif surf.match(line): 
			field  = 'surf'
			hash[protein][field] =  {'Seq':'','SS':'','Conf':''}
			
		elif start.match(line) and field: 
			hash[protein][field]['Seq']  += re.sub(' ', '', file.readline()[:-1]) 
			hash[protein][field]['SS']   += re.sub(' ', '', file.readline()[:-1])
			hash[protein][field]['Conf'] += re.sub(' ', '', file.readline()[:-1])
			
		elif stop.match(line):  field = None 
		
		
	file.close()
	return hash 


def runSable(seq): 
	
	os.system('rm /home/chrisf/steinar/data.seq')
	os.system('rm -rf /home/chrisf/steinar/OUT_SABLE*')
	os.system('rm -rf /home/genome/sable/OUT_SABLE*')
	input  = '/home/genome/sable/data.seq'
	output = '/home/chrisf/steinar/OUT_SABLE_RES'
	file = open(input, 'w')
	file.write(seq)
	file.close()
	input =  '/home/chrisf/steinar/data.seq'
	file = open(input, 'w')
	file.write(seq)
	file.close()
	cmd = '/home/genome/sable/run.sable'
	os.system(cmd)
	obj = sableRecord(parseSable(output))
	return obj


	
class sableRecord: 

	def __init__(self, hash): self.hash = hash
	def getSStructure(self, org)    : return self.hash[org]['struct']['SS']
	def getSSConf(self, org)        : return self.hash[org]['struct']['Conf']
	def getSAccessibility(self, org): return self.hash[org]['surf']['SS']
	def getSAConf(self, org)        : return self.hash[org]['surf']['Conf']
		


if __name__ == '__main__':  pass


def dummy():
	filename = 'OUT_SABLE_RES'
	hash = parseSable(filename)
	for key, value in hash.items():
		print key
		for key, value in value.items(): 
			print key
			for key, value in value.items(): print "%s%-5s:%s" %(len(value), key ,value)
			

if __name__ == '__main__': dummy()			
